// Mazeing
// include file containing global variables associated Mazeing

#ifdef _DEBUG
//#define SHOWTRACE			// uncomment to trace path generation in real time	
#endif


// cell array (Cell) masking bits
#define USED 	(1)					// cell has been already used in a path
#define TOP 	(1<<1)				// top line to be drawn
#define LFT 	(1<<2)				// left line to be drawn
#define ENTRY 	(1<<3)				// this cell is an entry (or exit)
#define TODO 	(1<<4)				// this cell is to be tested for a branch path
#define VISITED	(1<<5)				// this cell has been visited before

// current array (Cur) masking bits
#define	DIR		(3)					// current direction (0 to 3) being tested
#define UP		(1<<2)				// up direction has been tested
#define RT		(1<<3)				// right direction has been tested
#define DN		(1<<4)				// down direction has been tested
#define LT		(1<<5)				// left direction has been tested

// macro to get easy reference to the Cell[] array using two dimensions
#define CELL(xi, yi)	Cell[((unsigned)(xi) * (unsigned)yd + (unsigned)(yi))]

#define RESTART_STEP 100			// nbr of resets before giving up
#define TEST_INTERVAL 50			// test for progress this number of interations
#define MIN_PROGRESS 10				// minimum allowable progress between tests

#define MAX_GEN_MODE 9				// value of MazeGenMode when processing the last generation step

extern int MazeGenMode ;			// contains the current state of the maze generation sequence
extern unsigned DrawingDone ;		// number of cells drawn so far (used in printing dialog box)

extern unsigned AutoPrintMazes ;	// nbr of mazes left to auto generate
extern unsigned AutoPrintBlank ;    // nbr of blank (unsolved) mazes per auto generation
extern unsigned AutoPrintSolution ; // nbr of solved mazes per auto generation
extern unsigned AutoPrintCount ;	// serial count of the maze created by auto generation

extern int MouseIndex ;				// index of the current mouse position in the TPath?[] array
extern unsigned MouseFlags ;				// current state of the mouse buttons, etc
extern int MouseOnTrack ;           // true if the mouse is on the track (ie showing pencil cursor)
extern int MouseX, MouseY ;			// current position of the mouse expressed as a maze cell
extern int FAR *TPathX ;  			// path of the track drawn by the user (also temp usage)
extern int FAR *TPathY ;  			// ditto ...
extern int TrackLength ;			// length of the track as drawn by the user
extern long int TrackTime ;         // start time that the user attempts to solve the maze

extern HCURSOR DefaultCursor ;		// handle to the standard pointer cursor
extern HCURSOR PencilCursor ;		// handle to the pencil cursor

extern int xd, yd ;					// cell matrix width and height
extern int ValidMaze ;				// true when there is a maze to draw
extern long int StartTime ;			// start time when calculating the maze
extern long ProgressCnt ;           // count of the progress in solving maze
extern int ShowSolution ;			// show the solution to the maze
extern int ShowTrack ;				// show the track the user may have drawn
extern int BeepOnComplete ;			// make a sound when finished generating maze 
extern int FirstTimeThrough ;		// if true this is the first time the user has used Mazeing

extern int FAR *PathX ;				// X component of path of the solution of the maze
extern int FAR *PathY ;				// Y component of path of the solution of the maze
extern int PathLength ;				// length of the solution to the maze
extern unsigned char  FAR *Cell ;   // array of cells containing wall details, etc

extern CWnd *pMainWnd ;				// pointer to the main window for Invalidate()

extern CPrintDialog *pPrintDialog ;	// pointer to the print setup box for non member functs
extern CPrintCancelDlg PrintCancelDlg;	// print cancel dlg
extern CCalcCancel CalcCancel;	// calculation cancel dlg
extern int ValidCalcCancelDlg ;		// true when the cancel dialog is created and in control
extern int AbortPrint ;				// true if the print job is to be cancelled

extern int MazeOnIdle() ;
extern void LockArrays() ;
extern void UnLockArrays() ;
void FreeArrays() ;
int AllocateArrays() ;
extern void AbortMsg(char *szFormat, ...) ;
extern void NotifyMsg(char *szFormat, ...) ;
extern void DrawMaze(CDC *dc) ;
extern void DrawWall(CDC *dc, int x, int y, int dx, int dy, int len, int horiz) ;
extern void DrawSolution(CDC *dc) ;
extern void ProcessMouseClick(CDC *dc) ;
extern void DrawTrackLine(CDC *dc, int i) ;
extern void WriteProfileSize(CWnd *wnd) ;
extern void WriteProfileMargins() ;

extern CString MTop, MBot, MRgt, MLft ;		// variables holding the page margin sizes
extern int GetMarginSize(CDC *dc, CString str) ; // function to get a margin in pixels
extern BOOL DoPrintMaze(int Copies, BOOL PrtSolution, BOOL PrtTracks, CString Title) ;
